program triangulo;
     uses
       crt;
             {Las variables corresponden a:

             - "num_filas" es la altura del tringulo rectngulo
             - "num_columnas" es su base
             - "i" y "j" son los contadores correspondientes a las coordenadas en abscisas y ordenadas
             - "op" la utilizamos para elegir entre hueco o lleno
             - "fin" la utilizamos para acabar el programa o seguir dibujando
             - "k" es la constante del teorema de Tales de Mileto de proporcionalidad de tringulos }
     var
       num_filas,num_columnas,i,j,op,fin:integer;
       k:integer;

     begin

       repeat
         ClrScr;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('                         -----------------------------');
         writeln('                        |   Datos para el tringulo   |');
         writeln('                         ----------------------------- ');
         writeln;
         writeln;

       {$I-}

         writeln('Por favor, escriba el nmero de columnas (entre 1 y 80): ');
         readln(num_columnas);
         writeln;
         writeln;



          {Escribimos este comando (IOResult) para darle robustez al programa,
          impidiendo que se escriban letras en las elecciones.
          Los $I sirven para que funcione el IOResult.
          Adems, seguir repitiendo el error si se introduce un nmero fuera de rango,
          por lo tanto ponemos los "or" en el IOResult restringiendo la eleccin del nmero.}

         while ((IOResult<>0)or(num_columnas<1)or(num_columnas>80)) do

             begin
                writeln('<<<  ERROR  >>>   Elija un nmero entre 1 y 80: ');
                readln(num_columnas);
                writeln;
             end;

         writeln('Por favor, escriba el nmero de filas (entre 1 y 24): ');
         readln(num_filas);

         writeln;
         writeln;

         while ((IOResult<>0)or(num_filas<1)or(num_filas>24)) do


         {Este IOResult es lo mismo de antes, pero con el rango de las filas. As evitamos errores.}
            begin
              writeln('<<<  ERROR  >>>,   Elija un nmero entre 1 y 24: ');
              readln(num_filas);
              writeln;
            end;


         writeln;
         writeln;
         writeln('                         ----------------------------- ');
         writeln('                        |      tipo de tringulo      |  ');
         writeln('                         ----------------------------- ');
         writeln;
         writeln;

         writeln('Por favor, elija entre tringulo lleno (1) o hueco (2)): ');
         readln(op);


         while NOT((IOResult=0)and((op=1)or(op=2))) do

            begin
                writeln;

                writeln('<<<  ERROR  >>>, Teclee 1 para dibujarlo lleno, o 2 para que sea vaco: ');
                readln(op);
            end;



         {$I+}




                               {triangulo lleno}

            If op=1 then

              begin
                {Empezando por 1, y hasta el nmero de filas, porque formamos
                el tringulo de arriba a abajo}
                for j:=1 to num_filas do

                   begin

                   {Con este "for", vamos de izquierda a derecha escribiendo
                   asteriscos o huecos, y al llegar a la posicin de num_columna,
                   saltamos de lnea y vuelta a empezar.}
                      for i:=1 to num_columnas do

                        begin

                           {La K, constante de proporcionalidad en todo tringulo
                           rectngulo, es lo que determina el avance de asteriscos
                           en cada fila, es decir, la distancia entre el empiece de cada
                           fila de asteriscos}

                           k:=j*num_columnas div num_filas;

                             If i>=k  then

                               {Como el DIV solo coge la parte entera de la divisin,
                               aprovechamos eso para ir comparando con la columna en la que
                               nos encontramos. Dependiendo de un valor u otro, el programa escribir
                               asterisco o hueco.}

                               write('*')
                             else

                               write(' ');
                        end;

                               writeln;

                   end;
              end;





                              {triangulo hueco}

            If op=2 then

              begin

                  for j:=1 to num_filas do

                     begin

                        for i:=1 to num_columnas do

                           begin

                             {Lo anterior es igual que en el lleno. La diferencia entre uno y otro
                             es que ponemos el if condicional para que cuando se cumpla CUALQUIERA
                             de las 3 proposiciones, dibuje asterisco, de ah los OR.
                             La primera es para la primera fila.
                             La segunda es para la ltima columna
                             Y la tercera crea la diagonal}

                             if ((j=1) OR (i=num_columnas) OR (i=j*num_columnas DIV num_filas)) then

                                write('*')

                             else

                                write(' ');
                           end;

                                writeln;
                     end;
              end;






 {$I-}
         writeln('Si desea dibujar otro tringulo, pulse 1. Si no, pulse 2.): ');
         readln(fin);


         while NOT((IOResult=0)and((fin=1)or(fin=2))) do

           begin
             writeln('<<<  ERROR  >>>, 1 para repetir, 2 para salir: ');
             readln(fin);
           end;
           {Mientras no se teclee 1  2, repetir la pregunta.}
 {$I+}


       Until fin=2;
       {Con esto cerramos el repeat inicial, cerrando el programa.}



     END.