Program TrianguloRectangulo;

Uses
      crt;

Const
      vacio=' ';
      lleno='*';

Var
      error:boolean;
      filas,columnas,f,c,dif,compensar:byte;
      fondo,repetir:char;

Begin

     {Bucle para preguntar si desea dibujar otro triangulo}

     Repeat

        {Bucle de validacin de filas>columnas ver documentacion adjunta}

        Repeat

              clrscr;
              gotoXY(1,1);
              write('Introduzca el nmero de filas: ');

              {Bucle de validacin de introduccin de filas}

              Repeat

                    {$I-}
                    readln(filas);

                    {Se produce un error, cuando el sistema da un error o
                    cuando las filas son mayores a 24 o menores o iguales a 0}

                    If (ioresult<>0) or (filas>24) or (filas<=0) then
                    Begin

                         error:=true;
                         gotoXY(1,24);
                         write('Error en el dato fila. Se requiere un nmero entre 1 y 24');
                         gotoXY(32,1);
                         write('                                                 ');
                         gotoXY(32,1);
                    End
                    else
                    Begin
                         error:=false;
                         gotoXY(1,24);
                         write('                                                         ');
                    End
                    {$I+}
              until error=false;

              gotoXY(1,2);
              write('Introduzca el nmero de columnas: ');
              Repeat
                    {$I-}
                    readln(columnas);

                    {Se produce un error, cuando el sistema da un error o
                    cuando las columnas son mayores a 80 o menores o iguales a 0}

                    If (ioresult<>0) or (columnas>80) or (columnas<=0) then
                    Begin
                         error:=true;
                         gotoXY(1,24);
                         write('Error en el dato columna. Se requiere un nmero entre 1 y 80');
                         gotoXY(35,2);
                         write('                                                   ');
                         gotoXY(35,2);
                    End
                    else
                    Begin
                         error:=false;
                         gotoXY(1,24);
                         write('                                                             ');
                    End
                    {$I+}
              until error=false;

              {Mostar mensaje de error en el caso de que el nmero de filas sea mayor que el nmero de columnas}

              If(columnas<filas) then
              Begin
                  gotoXY(1,24);
                  write('Error. Se requiere columnas>=filas.');
                  readln;
              End
              else
              Begin
                  gotoXY(1,24);
                  write('                                               ');
              End;
        until (columnas>=filas);
        gotoXY(1,3);
        write('Introduzca si quiere el triangulo lleno o hueco (L o H): ');

        Repeat
             {$I-}
             readln(fondo);
             fondo:=upcase(fondo);{la funcin upcase nos devuelve el carcter mayscula si introducimos una minscula}

             {Nos da un mensaje de error si no introducimos ni L ni H}
             If (ioresult<>0) or ((fondo<>'L') and (fondo<>'H')) then
             Begin
                  error:=true;
                  gotoXY(1,24);
                  write('Error en el dato Fondo. Se requiere L o H.');
                  gotoXY(58,3);
                  write('                                         ');
                  gotoXY(58,3);
             End
             else
             Begin
                 error:=false;
                 gotoXY(1,24);
                 write('                                           ');
             End
             {$I+}
        until error=false;

        clrscr;
        dif:=trunc(columnas div filas); {Mediante trunc quitamos la parte decimal y nos quedamos con la parte entera}
        If columnas mod filas>0 then dif:=dif + 1;

        compensar:=0;

        {La variable compensar:=1 cuando las columnas y las filas sean un nmero par y adems este nmero es distinto, o cuando
        las filas sean impar y las columnas par}

        If((columnas mod 2=0) and (filas mod 2=0) and (columnas<>filas)) or
         ((filas mod 2<>0) and (columnas mod 2=0)) then
                compensar:=1;

        {Este for recorre el ancho del tringulo, dato que se ha introducido anteriormente
        por teclado}

        For f:=0 to columnas-1 do
        Begin

         {Cada lnea que dibujamos del tringulo tiene espacios en blanco y asteriscos,
         la primera lnea no tendr espacios en blanco y la ltima tendr todos menos
         el pico del tringulo}

             {Este bucle dibuja los espacios en blanco}

             For c:=0 to f*dif+compensar do
             Begin
                  write(vacio);
             End;

             {Este for dibuja los asteriscos}

             For c:=f*dif to columnas-1 do
             Begin

              {Si es la primera fila, siempre dibujamos *, si es la ltima columna tambin
              dibujamos *, con esto dibujamos los lados del tringulo}
              {Si lo queremos lleno, tambin habr que poner un *, eso es cuando fondo=L,
              en este for estamos dentro del tringulo, el anterior for est fuera del
              tringulo}

                  if(f=0) or (c=f*dif) or (c=columnas-1) or (fondo='L') then
                       write(lleno)
                  else
                       write(vacio)
             End;
             writeln;
        End;

        gotoXY(1,24);
        write('Desea dibujar otro tiangulo? (S/N): ');

        Repeat
             {$I-}
             readln(repetir);
             repetir:=upcase(repetir);
             If (ioresult<>0) or ((repetir<>'S') and (repetir<>'N')) then
             Begin
                  error:=true;
                  gotoXY(1,24);
                  write('Error en el dato Repetir. Se requere S o N.');
                  gotoXY(38,23);
                  write('                                         ');
                  gotoXY(38,23);
             End
             else
             Begin
                 error:=false;
                 gotoXY(1,24);
                 write('                                           ');
             End
             {$I+}
        until error=false;
     until repetir='N';
     clrscr;
     writeln('Practica realizada por: Carlos Suarez Marquina,Laura Pelayo Abascal.');
     writeln('Asignatura: Fundamentos de Informtica.');
     writeln('Ingeniera Tcnica Industrial, especialidad Qumica Industrial.');
     writeln('Curso 2008-2009');
     gotoxy(1,24);
     writeln('Pulse cualquier tecla para salir...');
     readln;
End.