program triangulos;

uses crt;   {unidad Crt, para usar ClrScr y textcolor}

var filas,columnas,ncolumnas,i,j:integer;
    tipoT,salir: char;

begin

  repeat
    {$I-} {Deshabilita el sistema de interrupciones de E/S}
    ClrScr;

    writeln;
    textcolor(lightRed);
    writeln(' * DIBUJA TRIANGULOS RECTANGULOS *');
    writeln;

    {1.Datos del tringulo}

    {1.1.Altura}
    repeat
      textcolor(lightGreen);
      writeln;
      write(' Introduce el nmero de filas (altura del tringulo): ');
      readln(filas);
      If (filas>24) or (filas<2) then begin
         textcolor(white);
         writeln(' El valor debe estar comprendido entre 2 y 24') end;
    until (IOResult=0) and ((filas>1) and (filas<25));

    {1.2.Anchura}
    repeat
      textcolor(lightGreen);
      writeln;
      write(' Introduce el nmero de columnas (anchura del tringulo): ');
      readln(columnas);
      If (columnas>80) or (columnas<2) then begin
         textcolor(white);
         writeln(' El valor debe estar comprendido entre 2 y 80'); end;
    until (IOResult=0) and ((columnas>1) and (columnas<81));

    {1.3.Tipo}
    repeat
      writeln;
      write(' Elige el tipo de tringulo. R=Relleno, H=Hueco : ');
      readln(tipoT);
    until (IOResult=0) and ((tipoT='R') or (tipoT='r') or (tipoT='H') or
                           (tipoT='h'));
    writeln;


    {2. Dibujo del tringulo}
    textcolor(lightcyan);

    For i:=filas downto 1 do begin
      ncolumnas:=((columnas * i) div filas);
      {frmula para determinar el numero de columnas que corresponden
         a cada fila del tringulo. (Por semejanza de tringulos).}

         For j:=1 to columnas do begin

            If (i=filas) or
               (((tipoT='R') or (tipoT='r')) and (j>(columnas-ncolumnas))) or
               (((tipoT='H') or (tipoT='h')) and (j=columnas-ncolumnas+1)) or
               (j=columnas) then
               {Dibuja '+' si se cumple alguna de las condiciones, sino
                  dibuja espacio:}
               write('+') else write(' ');

         end;
         writeln;   {Desciende a la siguiente fila}
    end;

    {3.Salir o dibujar otro tringulo}
    repeat
       writeln;
       textcolor(Yellow);
       write(' S=Salir, D=Dibujar otro tringulo: ');
       readln(salir);
    until (IOResult=0) and ((salir='S') or (salir='s') or (salir='D') or
                            (salir='d'));

  {$I+}
  until (salir='S') or (salir='s');

  writeln;
  textcolor(lightblue);
  writeln(' ____________________________________');
  writeln;
  writeln('  PROGRAMA REALIZADO POR LUIS LAMPLE ');
  writeln('               09/11/08              ');
  writeln(' ____________________________________');
  readln;

End.