Program Triangulos;

{Declaramos la biblioteca CTR para utilizar la procedimiento ClrScr}
uses
    Crt;

{Declaracon de variables}
Var
   columnas,filas:integer; {Los valores de columna y filas tienen que ser enteros}
   nombre:string[20]; {Utilizamos un string para pedir el nombre del usuario}
   resp1,resp2:char; {Las contestaciones de las respuestas que sepiden en la practica son de caracter char}
   j,l,m,n,p,q,t:integer; {Variables que necesitamos para realizar la practica}
   k:real; {La constante de proporcionalidad de un triangulo es de tipo real}

Begin

     {Inicio programa}

     ClrScr; {Utilizamos esta funcion de la biblioteca de CRT para limpiar la pantalla}

     {Utilizamos un encabezamiento para la introduccion del programa, seguido de una pregunta}

     writeln;
     writeln;
     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                  TRIANGULO RECTANGULO');
     writeln('--------------------------------------------------------------------------------');

     Writeln;
     writeln('Bienvenido al programa de dibujar triangulos rectangulos.');
     writeln;
     writeln('Esperamos que le sea de utilidad.');
     writeln;


     {Utilizamos esta simbologia para que el programa evalue cualquier entrada robusta de  datos mediante IOResult}

     {$I-}

     {Le pedimos al usuario su nombre}

     write('Podria decirnos su nombre?: ');
     readln(nombre);

     {Utilizamos while para ver que el valor introducido es correcto,sino se le pide de nuevo hasta que sea correcto}

     While (IOResult <> 0) Do
           Begin
                writeln;
                write('Nombre incorrecto, por favor, introduzcalo de nuevo: ');
                readln(nombre);
           End;

     {Utilizamos repeat para repetir el programa ya que nos piden que hasta que no quier el ususario otro no salir de el}

 Repeat

           {No utilizamos un begin, ya que la funcion repeat es la unica que esta cerrada}

           ClrScr; {Limpiamos otra vez la pantalla}

           {Utilizamos otro encabezamiento para una peticion de datos sobre el triangulo,y las  preguntas necesarias}

           writeln;
           writeln;
           writeln;
           writeln('--------------------------------------------------------------------------------');
           writeln('                                  PETICION DE DATOS');
           writeln('--------------------------------------------------------------------------------');

           writeln;
           write('De cuantas columnas desea que conste su triangulo ',nombre,'?(max 80): ');
           readln(columnas);
           while ((IOResult <> 0) or (columnas > 80) or (columnas < 1)) Do
                  Begin
                       writeln;
                       write('Numero de columnas incorrecto, porfavor introduce el numero de nuevo: ');
                       readln(columnas);
                  End;

           writeln;
           write('De cuantas filas desea que conste su triangulo ',nombre,'?(max 24): ');
           readln(filas);
           while ((IOResult <> 0) or (filas > 24) or (filas < 1)) Do
                 Begin
                      writeln;
                      write('Numero de filas incorrecto, porfavor introduce el numero de nuevo: ');
                      readln(filas);
                 End;

           writeln;
           writeln('Desea que su triangulo sea hueco por dentro ',nombre,'?');
           writeln;
           write('Pulsar S (Si) o N (No): ');
           readln(resp1);
           while NOT ((resp1 = 's') or (resp1 = 'S') or (resp1 = 'n') or (resp1 = 'N')) Do
                 Begin
                      writeln;
                      write('Por favor pulse S(Si) o N(No): ');
                      readln(resp1);
                 End;

     {$I+}

     {Cerramos la introduccion robusta de datos de la funcion IOResult}

     {Inicio de los procedimientos para crear el triangulo}

                   ClrScr; {limpiamos otra vez la pantalla}

                   {Hacemos uan pantalla para que se vea que se esta creando el triangulo}

                   writeln;
                   writeln;
                   writeln;
                   writeln;
                   writeln;
                   writeln;
                   writeln;
                   writeln('--------------------------------------------------------------------------------');
                   writeln('                                  CREANDO TRIANGULO');
                   writeln('--------------------------------------------------------------------------------');

                   writeln;
                   writeln;
                   writeln;
                   writeln('--------------------------------------------------------------------------------');
                   writeln('                    Pulsar cualquier tecla para ver el resultado');
                   writeln('--------------------------------------------------------------------------------');
                   readln;

                   ClrScr; {Limpiamos otra vez la pantalla}

                   {Valores que necesitamos para la realizacion del triangulo, dandole aqui su valor inicial}
                   k:=((filas)/(columnas)); {k es la relacion de filas y columnas de un triangulo mediante una division real}
                   j:=0; {contador que utilizamos para parar cuando sea necesario el repeat siguiente}
                   m:=filas;
                   n:=columnas;
                   p:=columnas;
                   t:=1;

                   Repeat

                         {Hemos intentado unir todo el triangulo en un mismo proceso pero no lo hemos conseguido}

                         {Lo que hemos conseguido es quitar los dos programas que teniamos entre hueco y lleno y lo}
                         {hemos hecho en uno, diferenciandolo en la parte central del triangulo}

                         {para dibujar la primera fila}
                         If n= columnas then
                            begin
                                 repeat
                                       {Dibujaremos en todos casos desde la posicion de columnas hacia puntos de x menor}
                                       Gotoxy(p,1);
                                       write('*');
                                       p:=p-1; {utilizamos este caluculo para movernos por los valores de x, hasat que sea 0}
                                 until p=0;
                            end;

                         {Dentro del siguiente if diferenciaremos el modo de dibujar el triangulo, si es hueco o lleno}

                         {para dibujar todas las filas del triangulo menso la primera y la ultima}
                         If ((j > 0) and (j < (filas-1)) or (l>0)) then
                            begin
                                 If ((resp1='n') or (resp1='N')) then
                                    begin
                                         repeat
                                               Gotoxy(p,m);
                                               write('*');
                                               p:=p-1;
                                         until p=l;
                                    end;

                                 If ((resp1='s') or (resp1='S')) then
                                    begin
                                         l:=l+1;
                                         Gotoxy(columnas,m);{utilizamso gotoXY para colocarnos en el punto que pedimos}
                                         write('*');
                                         Gotoxy(l,m); {para dibujar el * en el punto final de la distancia}
                                         write('*');
                                    end;
                            end;

                         {para dibujar la ultima fila del triangulo}
                         If ((t=filas) or (l<=0)) then
                            begin
                                 Gotoxy(columnas,filas);
                                 write('*');
                            end;

                         writeln; {para pasar a la linea de abajo de la que estamso dibujando}
                         n:=0; {cambiamos el valor de n, inicialmente numero de columnas, al valor 0}
                         j:=j+1; {sumamos siempre un valor mas de j para cuando j sea igual a filas salir del repeat}
                         m:=m-1; {restamso una unidad a m para colocarnos en la fila en la que nos situamos actualmente}
                         l:=round((m-1)/ k); {l,distancia de fila del triangulo en la que nos situamos,utilizando round}
                         p:=columnas; {n despues de dibujar una fila se queda con el valor 0}
                         t:=1+t; {esta variable es para utilizarla para dibujar la ultima fila}


                   until j=filas;

           {Fin de los procedimientos para dibujar el triangulo}

           {paramos el programa para que el usuario vea el triangulo, y cuando el usuario pulse uan tecla continuar}

           writeln('--------------------------------------------------------------------------------');
           writeln('Pulsar cualquier tecla para continuar');
           writeln('--------------------------------------------------------------------------------');
           readln;

           ClrScr; {limpiamos otra vez la pantalla}

           {encabezamiento de la pregunta de si quiere otro triangulo}

           writeln;
           writeln;
           writeln;
           writeln('--------------------------------------------------------------------------------');
           writeln('                                  PREGUNTA FINAL');
           writeln('--------------------------------------------------------------------------------');

           {$I-} {para evaluar de nuevo la entrada de datos por IOResult}

           writeln;
           writeln('Desea dibujar otro triangulo ',nombre,'?: ');
           writeln;
           write('Pulsar S (Si) o N (No): ');
           readln(resp2);
           while NOT ((resp2 = 's') or (resp2 = 'S') or (resp2 = 'n') or (resp2 = 'N')) Do
                 begin
                      writeln;
                      write('Por favor pulse S(Si) o N(No): ');
                      readln(resp2);
                 end;

           {$I+} {cerramos la evaluacion de entrada de datos que evalua IOResult}

     {si la resuesta es igual a no entonces ponemos una especie de despedida}

     Until ((resp2 = 'N') or (resp2 = 'n'));
           begin
                writeln;
                writeln;
                writeln;
                writeln;
                writeln('Gracias por elegir nuestro programa ',nombre,'.');
                writeln;
                writeln('Pulse cualquier tecla para finalizar el programa.');

                writeln;
                writeln;
                writeln;
                writeln;
                writeln('Programa realizado por Guillermo Minguillon Blasco y Javier Sancho Lalana.');
                readln;
           end;

 {Fin del programa}

End.