Program DibujoDeTriangulos;

{Se creara un programa que dibuje en la pantalla un triangulo rectangulo que como maximo ocupe la pantalla}

Uses Crt;

Var

altura:integer;
base:integer;
coeficiente:integer;
aux2:integer;
aux:real;
i:byte;
x:byte;
y:byte;
estilo:char;
respuesta:char;
repeticion:boolean;

Begin
   coeficiente := 0;
   altura := 0;
   base := 0;
   x := 0;
   y := 0;
   repeticion:=True;

   {Pantalla de presentacion}
   TextBackGround(LightBlue);
   TextColor(Yellow);
   ClrScr;
   GotoXY(23,12);
   Write('DIBUJE SU PROPIO TRIANGULO RECTANGULO');
   GotoXY(28,15);
   TextColor(Yellow+128);
   Write('Pulse Enter para continuar');
   GotoXY(22,30);
   TextColor(Blue);
   TextBackGround(LightGray);
   Write('Autores: Javier Graus y Adrian Cabrejas');
   Readln;

   {Parte del algoritmo donde se piden las medidas del triangulo y el estilo del mismo}
   TextBackGround(LightGray);
   TextColor(Black);
   ClrScr;
   While repeticion=True do
      Begin
         Writeln; Writeln;
         {$I-}
         Write('Por favor escriba la base que desea que tenga su triangulo (max 80, min 2) ');
         Readln(base);
         Writeln;
         If (IOResult <> 0) or (base <= 1) or (base > 80) then
            Begin
               Repeat
                  TextColor(Red);
                  Write('ERROR, por favor vuelva a escribir la base del triangulo ');
                  TextColor(Black);
                  Readln(base);
                  Writeln;
               Until (IOResult = 0) and (base >= 2) and (base <= 80);
               Writeln;
            end;

        Write('Por favor escriba la altura que desea que tenga su triangulo (max 24, min 2) ');
        Readln(altura);
        Writeln;
        If (IOResult <> 0) or (altura <= 1) or (altura > 24)  then
           Begin
               Repeat
                  TextColor(Red);
                  Write('ERROR, por favor vuelva a escribir la altura del triangulo ');
                  TextColor(Black);
                  Readln(altura);
                  Writeln;
               Until (IOResult = 0) and (altura >= 2) and (altura <= 24);
               Writeln;
           end;

         Write('Indique el estilo que prefiere: Rectangulo relleno (L) o Rectangulo hueco (H) ');
         Readln(estilo);
	 Writeln;
         If (estilo <> 'L') and (estilo <> 'l') and (estilo <> 'H') and (estilo <> 'h') or (IOResult <> 0) then
            Begin
               Repeat
                  TextColor(Red);
                  Write('ERROR, por favor vuelva a escribir el estilo del triangulo ');
                  TextColor(Black);
                  Readln(estilo);
                  Writeln;
               Until (estilo = 'L') or (estilo = 'l') or (estilo = 'H') or (estilo = 'h') and (IOResult = 0);
            end;
         {$I+}
      ClrScr;

      {Cuerpo principal del algoritmo, dividido en dos partes: una dibuja un triandulo relleno y la otra no}
      {colocacion del triangulo en la pantalla}
      x := base div 2;
      y := altura div 2;
      x := 40 - x;
      y := 12 - y;
      For i := 1 to y do
         Begin
            writeln;
         end;
      TextColor(Green);
      If (estilo = 'L') or (estilo = 'l') {dibuja el triangulo relleno}
         then
            Begin
               while (base >= 1) and (altura >= 1) do
               begin
		     For i := 1 to x do
                        Begin
                           write(' ');
                        end;
                     For i := 1 to base do
                        Begin
                           write('*');
                        end;
		     altura := altura - 1;
		     aux := base / altura;
      	             coeficiente := Round(aux);
                     if Trunc(aux) = (aux - 0.5)
                     then coeficiente := Trunc(aux);
		     x := x + coeficiente;
                     base := base - coeficiente;
                     if (x + base) < 80 then writeln;
                     if (altura = 1) and (base = 0) then
                        begin
                           For i := 1 to (x - 1) do
                              Begin
                                 write(' ');
                              end;
                           write('*');
                        end;
                  end;
            end

         else {dibuja el triangulo hueco}
            while base >= 1 do
	     Begin
               aux2 := base;
               while (base >= 1) and (altura >= 1) do
               begin
		     For i := 1 to x do
                        Begin
                           write(' ');
                        end;
                     For i := 1 to base do
                        Begin
                           If (base/i = base) or (base/i = 1)
                              then write('*')
                              else
				Begin
                                   If aux2 = base
				      then write ('*')
				      else write(' ')
				end;
                        end;
		     altura := altura - 1;
		     aux := base / altura;
      	             coeficiente := Round(aux);
                     if Trunc(aux) = (aux - 0.5)
                     then coeficiente := Trunc(aux);
		     x := x + coeficiente;
                     base := base - coeficiente;
                     if (x + base) < 80 then writeln;
                     if (altura = 1) and (base = 0) then
                        begin
                           For i := 1 to (x - 1) do
                              Begin
                                 write(' ');
                              end;
                           write('*');
                        end;
                  end;
            end;

      {Se le pide al usuario si quiere continuar dibujando o prefiere finalizar el programa}
      {$I-}
      TextColor(Black);
      GotoXY(20,24);
      Write('Desea dibujar otro triangulo? S/N ');
      Readln(respuesta);
      If (respuesta <> 'S') and (respuesta <> 's') and (respuesta <> 'N') and (respuesta <> 'n') or (IOResult <> 0) then
            Begin
               Repeat
                  TextColor(Red);
                  Write('ERROR, por favor vuelva a escribir su respuesta ');
                  TextColor(Black);
                  Readln(respuesta);
               Until (respuesta = 'S') or (respuesta = 's') or (respuesta = 'N') or (respuesta = 'n') and (IOResult = 0);
            end;
      {$I+}
       Case respuesta of
          'S': repeticion := True;
          's': repeticion := True;
          'N': repeticion := False;
          'n': repeticion := False;
          end;
       ClrScr;
       end;
End.
