Program         triangulos;

Const   maxcol=80; {Como son valores fijos, empleamos constantes.}
        maxfil=24; {para que el programa sea ms robusto.}
        mincol=3;  {Estas dos constantes las hemos creado porque creemos }
        minfil=3;  {que hacen falta unos mnimos.(explicacin en .txt)}

var     col:integer;  {Variable que representa el num de columnas.}
        fil:integer;  {Variable que representa el num de filas.}
        dibu:char;    {Variable que representa el tipo de dibujo.}
        i:integer; {Las tres variables siguientes }
        j:integer; {son las usadas para}
        t:integer; {los bucles hechos con for.}
        k:integer; {Variable "puente" para no modificar la var col.}
        h:integer; {Variable "puente" para no modificar la var fil.}
        x:integer; {Variable para la construccin de tringulos irregulares.}
        opt:char;  {Variable para el menu de repeticin.}

Begin
     writeln('Bienvenido al programa de construccin de tringulos.');

  repeat
    begin
     {$I-}
     {Con este mdulo el usuario introduce el valor de fil}
     writeln('Por favor, introduzca el nmero de filas que desea que tenga su tringulo.');
     readln(fil);
     writeln;
     while not ((IOResult=0) and (fil>=minfil) and (fil<=maxfil)) do
          begin
               writeln('El nmero debe estar comprendido entre [3,24].');
               writeln;
               writeln('Por favor introduzca el nmero de filas que desea que tenga su tringulo.');
               readln(fil);
               writeln;
          end;
     {$I+}
     {$I-}
     {Con este mdulo el usuario introduce el valor de col}
     writeln('Introduzca ahora el nmero de columnas que desea que tenga.');
     readln(col);
     writeln;
     while not ((IOResult=0) and (col>=fil) and (col>=mincol) and (col<=maxcol)) do
           begin
                writeln('El nmero debe estar comprendido entre [3,80] y ser mayor o igual al de filas.');
                writeln;
                writeln('Por favor introduzca el nmero de columnas que desea que tenga.');
                readln(col);
                writeln;
           end;
     {$I+}
     {Con el siguiente mdulo el usuario elige si rellena o no el tringulo}
     writeln('Cmo desea que sea su tringulo?.');
     writeln('Si lo quiere completo, seleccione <L>, si lo prefiere hueco <H>.');
     readln(dibu);
     writeln;
     while not ((dibu='L') or (dibu='l') or (dibu='H') or (dibu='h')) do
           begin
                writeln('Opcin no vlida');
                writeln;
                writeln('Si lo quiere completo, seleccione <L>, si lo prefiere hueco <H>.');
                readln(dibu);
                writeln;
           end;

     If ((dibu='L') or (dibu='l')) then   {Mdulo que dibuja triangulos llenos}

         begin
              If (fil=col) then  {Parte para los que tienen igual nmero de}
                 begin           {filas que de columnas}
                  for i:=1 to col do
                   begin
                        write('*');
                   end;
                  writeln;
                  h:=(fil-1);
                  for i:=1 to h do
                   begin
                     for j:=1 to i do
                       begin
                          write(' ');
                       end;
                     for t:=(j+1) to col do
                       begin
                         write('*');
                       end;
                     writeln;
                   end;
                 end
              else {Parte en la que se dibujan aquellos que no tienen igual}
                  begin                        {nmero de filas y columnas.}
                       begin
                            for i:=1 to col do
                              write('*');
                       end;
                       writeln;
                       h:=fil-1;
                       x:=round(col div fil);
                       If not x>1 then
                          x:=col-fil;
                   for i:=1 to h do
                       begin
                            for j:=1 to (i*x) do
                             begin
                                write(' ');
                             end;
                            for t:=(j+1) to col do
                             begin
                                write('*');
                             end;
                            writeln('');
                       end;
                  end;
         end

     else    {Mdulo que dibuja tringulos huecos.}
          begin
              If (fil=col) then  {Parte perteneciente a los tringulos con igual}
                 begin           {nmero de filas que de columnas.}
                   begin
                        for i:=1 to col do
                            write('*');
                   end;
                   writeln;
                  h:=(fil-1);
                  k:=(col-1);
                  for i:=1 to h do
                   begin
                     for j:=1 to i do
                       begin
                          write(' ');
                       end;
                     write('*');
                     for t:=(j+2) to k do
                       begin
                          write(' ');
                       end;
                     If (i<>h) then
                     write('*');
                     writeln;
                   end;
                 end
              else {Parte para aquellos que no tienen igual nmero de filas que}
                  begin                                            {de columnas}
                   begin
                        for i:=1 to col do
                            write('*');
                   end;
                   writeln;
                       h:=fil-1;
                       k:=col-1;
                       x:=round(col div fil);
                       If not x>1 then
                          x:=col-fil;
                   for i:=1 to (h) do
                       begin
                            for j:=1 to (x*i) do
                              begin
                                   write(' ');
                              end;
                            write('*');
                            for t:=(j+2) to k do
                             begin
                                  write(' ');
                             end;
                            If (i<>h) then
                               write('*');
                               writeln;
                       end;
                  end;
         end;



     {Con el siguiente mdulo damos la opcin de repetir todo el programa.}
     writeln;
     writeln('Desea volver a dibujar un tringulo?.Escriba <S> o <N>.');
     readln(opt);
     writeln;
     while not ((opt='S') or (opt='s') or (opt='N') or (opt='n')) do
           begin
                writeln('Opcin no vlida!');
                writeln;
                writeln('Desea volver a dibujar un tringulo?.Escriba <S> o <N>.');
                readln(opt);
                writeln;
           end;
    end;
  until ((opt='N') or (opt='n'));


readln; {Lo ponemos para poder ver el final durante la ejecucin.}
End.