{****************************************************************************}
{Programa que pide al usuario una anchura y una altura para dibujar un       }
{tringulo. Adems se pide la posibilidad de mostrarlo relleno o hueco.      }

{****************************************************************************}


program triangulo;
uses crt;

var
   anchura:integer;     {anchura en columnas del tringulo. Valor mximo=80}
   altura:integer;      {altura en filas del tringulo. Valor mximo=24}
   relleno:char;        {variable que indica si el tringulo ser relleno=L 
                         hueco=H}
   repetir:char;        {variable que indica si el programa se repetir o no}
   istriangulo:boolean; {variable booleana que mostrar si se trata de un tringulo o no}
   decremento:integer;  {decremento de una fila a otra del triangulo}
   x,y,z:integer;       {contadores para los diferentes for}
   limite_y:integer;    {altura de los distintos niveles cuando altura > anchura}

begin

  repeat
    begin
     clrscr;

     {***** Peticin de la anchura al usuario con tratamiento de errores *****}
     Repeat
        begin
         Write('Introduce la anchura del tringulo: ');
         {$I-}
         Readln (anchura);
         while IOResult <> 0 do
            begin
               Write ('Introduce un nmero entero, por favor: ');
               readln(anchura);
            end;
         {$I+}
         if (anchura > 80) then
            Writeln('Anchura mxima = 80. Intntalo de nuevo');
        end;
     until (anchura <= 80);

     {*** Peticin de la altura al usuario con tratamiento de errores ***    }
     Repeat
        begin
         writeln;
         Write('Introduce la altura del tringulo: ');
         {$I-}
         Readln (altura);
         while IOResult <> 0 do
            begin
               Write ('Introduce un nmero entero, por favor: ');
               readln(altura);
            end;
         {$I+}
         if (altura > 24) then
            Writeln('Altura mxima = 24. Intntalo de nuevo');
        end;
     until (altura <= 24);

     {*** Peticin de relleno/hueco al usuario con tratamiento de errores ***}
     {El algoritmo es un poco distinto que nos anteriores porque ahora un    }
     {numero puede considerarse como un carcter sin generar por ello un error}
     writeln;
     Writeln('Selecciona con L si quieres dibujar un tringulo relleno,');
     Writeln('o bien con H si por el contrario quieres dibujar un');
     Write('tringulo hueco, ambas en mayusculas, por favor: ');
     Readln (relleno);
     while ((relleno <> 'L') and (relleno<> 'H')) do
        begin
          Write ('Introduce un carcter (L para relleno  H para hueco), por favor: ');
          readln(relleno);
        end;


     istriangulo:=true;
     decremento:=0;

     if (altura < anchura) then
       begin
        if ((anchura-1) mod (altura-1)) <> 0 then istriangulo:=false;
        for y:=1 to altura do
          begin
            for x:=1 to decremento do
              Write('_');
            for x:= (decremento + 1) to (anchura) do
              if (((x > (decremento + 1)) and (x < (anchura))) and (relleno ='H') and (y>1) ) then
                 write('_')
              else
                 write ('*');
            writeln;
            if y < altura then
               decremento:= decremento + ((anchura - decremento -1) div (altura - y))
          end;
       end
     else  {altura > anchura}
       begin
         if ((altura -1) mod (anchura -1)) <> 0 then istriangulo:=false;
         if ((altura-1) mod (anchura-1)) = 0 then
            limite_y:= (altura div anchura)
         else
            limite_y:=(altura div anchura)+1;
         for x:=1 to anchura do
            Write('*');
         writeln;
         decremento:=1;
         for x:=1 to (anchura -1) do
           begin
             for y:=1 to limite_y do

                if NOT((x=anchura-1) and (y>((altura -1) div (anchura -1)))) then
                  begin
                    for z:=1 to decremento do
                      Write('_');
                    for z:= (decremento + 1) to (anchura) do
                      if (((z > (decremento + 1)) and (z < (anchura))) and (relleno ='H') ) then
                        write('_')
                      else
                        write ('*');
                    writeln;
                  end;

             decremento:= decremento +1;
           end;
       end;


     if istriangulo = false then
        writeln('Esto no es un tringulo perfecto aunque tenga el ngulo recto.');

     {Writeln; }

     Write('Quieres volver a dibujar un tringulo... S o N (en mayusculas) ?');
     Readln (repetir);
     if ((repetir <> 'S') and (repetir <> 'N')) then
        repeat
          begin
           writeln;
           Write ('Introduce un carcter (S  N (en mayusculas), por favor: ');
           readln(repetir);
          end;
        until (repetir = 'S') or (repetir ='N');
   end;
  until repetir='N';

end.
